
#property indicator_separate_window
#property indicator_minimum 0
#property indicator_maximum 100
#property indicator_level1 30
#property indicator_level2 50
#property indicator_level3 70
#property indicator_level4 20
#property indicator_level5 80
#property indicator_levelcolor RoyalBlue
#property indicator_buffers 4
#property indicator_color1 SkyBlue
#property indicator_color2 Orange
#property indicator_color3 Lime
#property indicator_color4 Red
//---- input parameters
extern int Indperiod=14;
extern int KPeriod=5;
//extern int HighLow=0;
//---- indicator buffers
double Line1Buffer[];
double Line2Buffer[];
double Line3Buffer[];
double Line4Buffer[];
double Line01Buffer[];
double Line02Buffer[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function |
//+------------------------------------------------------------------+
int init()
{
string short_name;
//---- indicator line
SetIndexStyle(0,DRAW_LINE);
SetIndexStyle(1,DRAW_LINE);
SetIndexStyle(2,DRAW_LINE);
SetIndexStyle(3,DRAW_LINE,2,0);
IndicatorBuffers(6);
SetIndexBuffer(0,Line01Buffer);
SetIndexBuffer(1,Line02Buffer);
SetIndexBuffer(2,Line3Buffer);
SetIndexBuffer(3,Line4Buffer);
SetIndexBuffer(4,Line1Buffer);
SetIndexBuffer(5,Line2Buffer);
IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));
//---- name for DataWindow and indicator subwindow label
short_name="RSI_MFI_Stoch_WPR("+Indperiod+","+KPeriod+")";
IndicatorShortName(short_name);
SetIndexLabel(0,"RSI");
SetIndexLabel(1,"MFI");
SetIndexLabel(2,"Stochastic");
SetIndexLabel(3,"WPR");
//----
SetIndexDrawBegin(0,1);
SetIndexDrawBegin(1,1);
SetIndexDrawBegin(2,1);
SetIndexDrawBegin(3,1);
//----
return(0);
}
//+------------------------------------------------------------------+
//| StepRSI_v2 |
//+------------------------------------------------------------------+
int start() {
   int  counted_bars=IndicatorCounted();
   if (counted_bars>0) counted_bars--;
   int limit=Bars-counted_bars;

   int shift;

   for(shift=limit;shift>=0;shift--) {
      Line1Buffer[shift]=iRSI(NULL,0,Indperiod,PRICE_CLOSE,shift);
      Line2Buffer[shift]=iMFI(NULL,0,Indperiod,shift);
      Line3Buffer[shift]=iStochastic(NULL,0,KPeriod,KPeriod,KPeriod,MODE_EMA,PRICE_CLOSE,MODE_MAIN,shift);
      Line4Buffer[shift]=iWPR(NULL,0,Indperiod,shift)+100.0;
      
   }
   for(shift=limit;shift>=0;shift--) 
     {  
       Line01Buffer[shift]=iMAOnArray(Line1Buffer,0,KPeriod,0,MODE_SMMA,shift);
       Line02Buffer[shift]=iMAOnArray(Line2Buffer,0,KPeriod,0,MODE_SMMA,shift);
     }         
   return(0);
}

//+------------------------------------------------------------------+


